 #!/usr/bin/perl

use warnings "all";
use strict;
#use POE qw(Loop::IO_Poll Wheel::SocketFactory Wheel::ReadWrite);
use POE qw(Wheel::SocketFactory Wheel::ReadWrite);
use Data::Dumper;
use slow_module;
use Socket qw( inet_ntoa IPPROTO_TCP TCP_NODELAY );

use base 'POE::Session::AttributeBased';





POE::Session->create
(
	heap=>{ SF=>undef, RW=>{}},
	__PACKAGE__->inline_states(),
);

slow_module::start;


POE::Kernel->run();
exit;


sub _start : State
{

	print "starting up\n";
	 # Set our alias
        $_[KERNEL]->alias_set( 'Server' );
        $_[SESSION]->option( 'alias' => 'Server' );

        # Create the server!
        $_[KERNEL]->yield( 'Create_Server' );

        # Setup the DIE handlers
        $_[KERNEL]->sig( 'DIE', 'death_handler' );

        # Automatically detach ourself!
        $_[KERNEL]->detach_myself;

        # All done!
        return;
}
sub _stop : State {return;}
sub _parent : State {return;}
sub _child : State {return;}

sub Create_Server : State
{
	print "creating sock factory\n";


	$_[HEAP]->{SF} = POE::Wheel::SocketFactory->new
	(
		BindPort 	=> 2502,
		BindAddress 	=> 'localhost',#'192.168.3.109',
		SuccessEvent 	=> "on_client_accept",
		FailureEvent 	=> "on_server_error",
		Reuse		=> 'on',
	);
}

sub on_client_accept : State
{
	print "got us a new client \n";
	my ($client_socket, $ip) = @_[ARG0,ARG1];
	eval 
	{
		if ( ! setsockopt( $client_socket, IPPROTO_TCP, TCP_NODELAY, 1 ) ) 
		{
			LOG_INFO( "failed to disable Nagle on TCP socket" );
		}
	};


	my $io_wheel = POE::Wheel::ReadWrite->new
	(
		Handle 		=> $client_socket,
		Driver		=> POE::Driver::SysRW->new(),
		Filter		=> POE::Filter::Line->new( 'Literal' => "\n" ),
		InputEvent 	=> "on_client_input",
		ErrorEvent 	=> "on_client_error",
	);
	$_[HEAP]->{RW}->{ $io_wheel->ID() } = $io_wheel,
}
sub on_server_error : State
{
	# Shut down server.
	my ($operation, $errnum, $errstr) = @_[ARG0, ARG1, ARG2];
	warn "Server $operation error $errnum: $errstr\n";
	delete $_[HEAP]->{SF};
	$_[KERNEL]->delay_set('Create_Server' =>15);
}
sub on_client_input : State 
{
	# Handle client input.
	my ($input, $wheel_id) = @_[ARG0, ARG1];
	print("received $input\n");
	my $conn=$_[HEAP]->{RW}->{$wheel_id};
	$_[KERNEL]->post('Slow','lag',$conn);
}

sub on_client_error : State 
{
	# Handle client error, including disconnect.
	my ($op, $err, $wheel_id) = @_[ARG0,ARG1,ARG3];
	print("got $op $err $wheel_id\n");
	delete $_[HEAP]->{RW}->{$wheel_id};
}

